import { Accountdata } from '@polkadot/types/interfaces'

export interface AccountBalance {
  accountId: string
  balance: AccountData
}

export interface ElectionInfo {
  durations: number[]
  stage: any
  round: number
  stageEndsAt: number
  termEndsAt: number
}

export interface ProposalDetail {
  created: number
  finalizedAt: number
  message: string
  parameters: string
  stage: any
  result: string
  exec: any
  id: number
  title: string
  description: any
  votes: VotingResults
  type: string
  votesByAccount?: Vote[]
  author?: string
  authorId: number
}

export interface Round {
  round: number
  start: number
  end: number
}

export class Bounty {
  constructor(
    public testnet: string,
    public proposalId: number,
    public title: string,
    public status: string,
    public amountAsked: number,
    public amountMinted: number
  ) {}
}

export class CacheEvent {
  constructor(
    public section: string,
    public method: string,
    public data: GenericEventData
  ) {}
}

export class MintStatistics {
  startMinted: number;
  endMinted: number;
  diffMinted: number;
  percMinted: number;

  constructor(
    startMinted: number = 0,
    endMinted: number = 0,
    diffMinted: number = 0,
    percMinted: number = 0
  ) {
    this.startMinted = startMinted;
    this.endMinted = endMinted;
    this.diffMinted = diffMinted;
    this.percMinted = percMinted;
  }
}

export interface WorkerReward {
  id: number;
  memberId: MemberId;
  account: AccountId;
  handle: string;
  stake: Stake;
  reward: RewardRelationship;
  status: string;
}